#python3
import time,_thread as thread
import socket
from func_timeout import func_set_timeout,FunctionTimedOut
import bluetooth

# set a def to get host ip
def get_host_ip():
    try:
        s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        s.connect(('8.8.8.8', 80))
        ip = s.getsockname()[0]
    finally:
        s.close()
    return ip
def now():
    return time.ctime(time.time())

def handleClient(conn,add):                # child process: reply,exit
    time.sleep(5)                          # simulate a blocking activity
    while True:                            # read , write a client socket
        print("You are able to send command now:")
        data = input()
        wholeinfo = 'command: '+data + ' is send '
        if moconn != "":
            moconn.send(str.encode(wholeinfo))                  #send data to sniffer
        if hiconn != "":
            hiconn.send(str.encode(wholeinfo))
            hidata = hiconn.recv(1024)
            moconn.send(hidata)
            server.send(bytes.decode(hidata))    #send command to Sparki
        else:
            server.send(data)
                
    conn.close()
    print('conncetion:',add, 'have closed')
    

ip = get_host_ip()
print("Local's IP is", ip)
HOST = str(ip)
PORT = 63200

# connect to the bluetooth
print ("Searching for devices...")
print ("")
nearby_devices = bluetooth.discover_devices()
num = 0
print ("Select your device by entering its coresponding number...")
for i in nearby_devices:
    print (num , ": " , bluetooth.lookup_name( i ))
    print ("    ", nearby_devices[num])
    num+=1
selection = int(input(">>"))
print ("You have selected", bluetooth.lookup_name(nearby_devices[selection]))
bd_addr = nearby_devices[selection]
print ("MAC Address :", bd_addr)
port = 1   # decide by the bluetooth opened port, it should be 1.
server = bluetooth.BluetoothSocket(bluetooth.RFCOMM)
server.connect((bd_addr, port))

# initialize the Sever
print ('initializing the server...')
sockets = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
sockets.bind((HOST,PORT))
sockets.listen(5)
i = 0
moconn=""
hiconn=""
print("Note:f means go forward, l means turn left, r means turn right")
while True:         # wait for client and sniffer                                    
    conn,add = sockets.accept()                     
    conn.send(str.encode('identify'))
    identifycode = conn.recv(1024)       # set the first connection as sniffer.
    if identifycode == b'sniffy':
        moconn = conn
    if identifycode == b'hijack':
        hiconn = conn
    #print('Server connected by', add, end = ' ', )
    #print('at',now())
    thread.start_new_thread(handleClient,(conn,add))  #  start a new thread when each client connect
